class KJanusWidget

# class KJanusWidget | Easy to use widget with many layouts. More...
Definition | `#include <kjanuswidget.h>`
Inherits | QWidget (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum Face { TreeList = 0, Tabbed, Plain, Swallow, IconList }

#### Public Methods

- KJanusWidget ( QWidget *parent=0, const char *name=0, int face=Plain )
- ~KJanusWidget ()
- virtual bool showPage ( int index )
- virtual int activePageIndex () const
- virtual bool isValid () const
- virtual int face () const
- virtual QSize minimumSizeHint () const
- virtual QSize sizeHint () const
- virtual QFrame * plainPage ()
- virtual QFrame * addPage (const QString &item,const QString &header=QString::null, const QPixmap &pixmap=QPixmap() )
- virtual QFrame * addPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() )
- virtual QVBox * addVBoxPage ( const QString &item, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() )
- virtual QVBox * addVBoxPage ( const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() )
- virtual QHBox * addHBoxPage ( const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() )
- virtual QHBox * addHBoxPage ( const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() )
- virtual QGrid * addGridPage ( int n, Orientation dir, const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() )
- virtual QGrid * addGridPage ( int n, Orientation dir, const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() )
- void removePage ( QWidget *page )
- virtual int pageIndex ( QWidget *widget ) const
- virtual bool setSwallowedWidget ( QWidget *widget )
- virtual void setTreeListAutoResize ( bool state )
- virtual void setShowIconsInTreeList (bool state)
- virtual void setRootIsDecorated ( bool state )
- virtual void setIconListAllVisible ( bool state )
- virtual void setFolderIcon (const QStringList &path, const QPixmap &pixmap)

#### Public Slots

- virtual void setFocus ()

#### Signals

- void aboutToShowPage (QWidget *page)

#### Public Members

- Forward IconListItem

#### Protected Methods

- virtual void showEvent ( QShowEvent * )
- virtual bool eventFilter ( QObject *o, QEvent *e )
- bool showPage ( QWidget *w )
- void addPageWidget ( QFrame *page, const QStringList &items, const QString &header, const QPixmap &pixmap )
- void InsertTreeListItem (const QStringList &items, const QPixmap &pixmap, QFrame *page)
- QWidget * FindParent ()
- virtual void virtual_hook ( int id, void* data )

## Detailed Description

Provides a number of ready to use layouts (faces). It is used as an internal widget in KDialogBase, but can also used as a widget of its own.

It provides TreeList, IconList, Tabbed, Plain and Swallow layouts.

The TreeList face provides a list in the left area and pages in the right. The area are separated by a movable splitter. The style is somewhat similar to the layout in the Control Center. A page is raised by selecting the corresponding tree list item.

The IconList face provides an icon list in the left area and pages in the right. For each entry the Icon is on top with the text below. The style is somewhat similar to the layout of the Eudora configuation dialog box. A page is raised by selecting the corresponding icon list item. The preferred icon size is 32x32 pixels.

The Tabbed face is a common tabbed widget. The procedure for creating a page is similar for creating a TreeList. This has the advantage that if your widget contain too many pages it is trivial to convert it into a TreeList. Just change the face in the KJanusWidget constructor to KJanusWidget::TreeList and you have a tree list layout instead.

The Plain face provides an empty widget (QFrame) where you can place your widgets. The KJanusWidget makes no assumptions regarding the contents so you are free to add whatever you want.

The Swallow face is provided in order to simplify the usage of existing widgets and to allow changing the visible widget. You specify the widget to be displayed by setSwallowedWidget(). Your widget will be reparented inside the widget. You can specify a Null (0) widget. A empty space is then displayed.

For all modes it is important that you specify the QWidget::minimumSize() on the page, plain widget or the swallowed widget. If you use a QLayout on the page, plain widget or the swallowed widget this will be taken care of automatically. The size is used when the KJanusWidget determines its own minimum size. You get the minimum size by using the minimumSizeHint() or sizeHint() methods.

Pages that have been added in TreeList, IconList or Tabbed mode can be removed by simply deleting the page.

enum Face { TreeList = 0, Tabbed, Plain, Swallow, IconList } | ### Face

KJanusWidget ( QWidget *parent=0, const char *name=0, int face=Plain ) | ### KJanusWidget

Constructor where you specify the face.

Parameters:

parent | Parent of the widget.
name | Widget name.
int | face The kind of dialog, Use TreeList, Tabbed, Plain or Swallow.

~KJanusWidget () | ### ~KJanusWidget

Destructor.

bool showPage ( int index ) | ### showPage

[virtual]

Raises the page which was added by addPage().

Parameters:

index | The index of the page you want to raise.

int activePageIndex () | ### activePageIndex

[const virtual]

Returns the index of the page that are currently displayed.

Returns: The index or -1 if the face is not Tabbed, TreeList or IconList.

bool isValid () | ### isValid

[const virtual]

Use this to verify that no memory allocation failed.

Returns: true if the widget was properly created.

int face () | ### face

[const virtual]

Returns the face type.

Returns: The face type.

QSize minimumSizeHint () | ### minimumSizeHint

[const virtual]

Returns the minimum size that must be made available for the widget so that UIs can be displayed properly

Returns: The minimum size.

QSize sizeHint () | ### sizeHint

[const virtual]

Returns the recommended size for the widget in order to be displayed properly.

Returns: The recommended size.

QFrame * plainPage () | ### plainPage

[virtual]

Returns the empty widget that is available in Plain mode.

Returns: The widget or 0 if the face in not Plain.

QFrame * addPage (const QString &item,const QString &header=QString::null, const QPixmap &pixmap=QPixmap() ) | ### addPage

[virtual]

Add a new page when the class is used in TreeList, IconList or Tabbed mode. The returned widget is empty and you must add your widgets as children to this widget. In most cases you must create a layout manager and associate it with this widget as well.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Parameters:

item | String used in the list or Tab item.
header | A longer string used in TreeList and IconList mode to describe the contents of a page. If empty, the item string will be used instead.
pixmap | Used in IconList mode or in TreeList mode. You should prefer a pixmap with size 32x32 pixels.

Returns: The empty page or 0 if the face is not TreeList, IconList or Tabbed.

QFrame * addPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() ) | ### addPage

[virtual]

This is like addPage just above, with the difference that the first element is a list of strings. These strings are used to form a path of folders down to the given page. The initial elements are names for the folders, while the last element is the name of the page. Note: This does yet only work for the TreeList face. Later this may be added for the IconList face too. In other faces than the TreeList, all the strings except the last one is ignored. Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

QVBox * addVBoxPage ( const QString &item, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() ) | ### addVBoxPage

[virtual]

Add a new page when the class is used in TreeList, IconList or Tabbed mode. The returned widget is empty and you must add your widgets as children to this widget. The returned widget is a QVBox so it contains a QVBoxLayout layout that lines up the child widgets are vertically.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Parameters:

item | String used in the list or Tab item.
header | A longer string used in TreeList and IconList mode to describe the contents of a page. If empty, the item string will be used instead.
pixmap | Used in IconList mode or in TreeList mode. You should prefer a pixmap with size 32x32 pixels.

Returns: The empty page or 0 if the face is not TreeList, IconList or Tabbed.

QVBox * addVBoxPage ( const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() ) | ### addVBoxPage

[virtual]

This is like addVBoxPage just above, with the difference that the first element is a list of strings. These strings are used to form a path of folders down to the given page. The initial elements are names for the folders, while the last element is the name of the page. Note: This does yet only work for the TreeList face. Later this may be added for the IconList face too. In other faces than the TreeList, all the strings except the last one is ignored.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

QHBox * addHBoxPage ( const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() ) | ### addHBoxPage

[virtual]

Add a new page when the class is used in TreeList, IconList or Tabbed mode. The returned widget is empty and you must add your widgets as children to this widget. The returned widget is a QHBox so it contains a QHBoxLayout layout that lines up the child widgets are horizontally.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Parameters:

item | String used in the list or Tab item.
header | A longer string used in TreeList and IconList mode to describe the contents of a page. If empty, the item string will be used instead.
pixmap | Used in IconList mode or in TreeList mode. You should prefer a pixmap with size 32x32 pixels.

Returns: The empty page or 0 if the face is not TreeList, IconList or Tabbed.

QHBox * addHBoxPage ( const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() ) | ### addHBoxPage

[virtual]

This is like addHBoxPage just above, with the difference that the first element is a list of strings. These strings are used to form a path of folders down to the given page. The initial elements are names for the folders, while the last element is the name of the page. Note: This does yet only work for the TreeList face. Later this may be added for the IconList face too. In other faces than the TreeList, all the strings except the last one is ignored.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

QGrid * addGridPage ( int n, Orientation dir, const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() ) | ### addGridPage

[virtual]

Add a new page when the class is used in either TreeList or Tabbed mode. The returned widget is empty and you must add your widgets as children to this widget. The returned widget is a QGrid so it contains a QGridLayout layout that places up the child widgets in a grid.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

Parameters:

n | Specifies the number of columns if 'dir' is QGrid::Horizontal or the number of rows if 'dir' is QGrid::Vertical.
dir | Can be QGrid::Horizontal or QGrid::Vertical.
item | String used in the list or Tab item.
header | A longer string used in TreeList and IconList mode to describe the contents of a page. If empty, the item string will be used instead.
pixmap | Used in IconList mode or in TreeList mode. You should prefer a pixmap with size 32x32 pixels.

Returns: The empty page or 0 if the face is not TreeList, IconList or Tabbed.

QGrid * addGridPage ( int n, Orientation dir, const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap() ) | ### addGridPage

[virtual]

This is like addGridPage just above, with the difference that the first element is a list of strings. These strings are used to form a path of folders down to the given page. The initial elements are names for the folders, while the last element is the name of the page. Note: This does yet only work for the TreeList face. Later this may be added for the IconList face too. In other faces than the TreeList, all the strings except the last one is ignored.

Deleting the returned frame will cause the listitem or tab to be removed (you can re-add a page with the same name later.

void removePage ( QWidget *page ) | ### removePage

Parameters:

page | The widget returned by addPage , addVBoxPage , addHBoxPage or addGridPage .

int pageIndex ( QWidget *widget ) | ### pageIndex

[const virtual]

Returns the index of a page created with addPage , addVBoxPage , addHBoxPage or addGridPage . You can can compare this index with the value returned from activePageIndex if you need to do some page specific actions in your code.

The returned index will never change so you can safely use this function once and save the value.

Parameters:

widget | The widget returned by addPage , addVBoxPage , addHBoxPage or addGridPage .

Returns: The index or -1 if the face is not Tabbed, TreeList or IconList

bool setSwallowedWidget ( QWidget *widget ) | ### setSwallowedWidget

[virtual]

Defines the widget to be swallowed.

This method can be used several times. Only the latest defined widget will be shown.

Parameters:

widget | The widget to be swallowed. If 0, then an empty rectangle is displayed.

void setTreeListAutoResize ( bool state ) | ### setTreeListAutoResize

[virtual]

This function has only effect in TreeList mode.

Defines how the tree list is resized when the widget is resized horizontally. By default the tree list keeps its width when the widget becomes wider.

Parameters:

state | The resize mode. If false (default) the TreeList keeps its current width when the widget becomes wider.

void setShowIconsInTreeList (bool state) | ### setShowIconsInTreeList

[virtual]

This function has only effect in TreeList mode.

This tells the widgets whether the icons given in the addPage, addVBoxPage, addHBoxPage, or addGridPage methods should be shown in the TreeList.

Note: This method must be called before calling any of the methods which add icons to the page.

Parameters:

state | If true the icons are shown.

void setRootIsDecorated ( bool state ) | ### setRootIsDecorated

[virtual]

This function has only effect in TreeList mode.

This tells the widgets whether the root should be decorated. For details see QListView::setRootIsDecorated

Parameters:

state | Root will be decorated if true.

void setIconListAllVisible ( bool state ) | ### setIconListAllVisible

[virtual]

This function has only effect in IconList mode.

Defines how the icon list widget is displayed. By default it is the widgets in the pages that decide the minimum height of the toplevel widget. A vertical scrollbar can be used in the icon list area.

Parameters:

state | The visibility mode. If true, the minimum height is adjusted so that every icon in the list is visible at the same time. The vertical scrollbar will never be visible.

void setFolderIcon (const QStringList &path, const QPixmap &pixmap) | ### setFolderIcon

[virtual]

Sets the icon used in TreeList Mode for the given path.

Parameters:

path | The path for which this icon should be shown.
pixmap | The icon used.

void aboutToShowPage (QWidget *page) | ### aboutToShowPage

[signal]

void setFocus () | ### setFocus

[virtual slot]

Give the keyboard input focus to the widget.

void showEvent ( QShowEvent * ) | ### showEvent

[protected virtual]

Reimplemented to handle the splitter width when the the face is TreeList

Reimplemented from QWidget.

bool eventFilter ( QObject *o, QEvent *e ) | ### eventFilter

[protected virtual]

This function is used internally when in IconList mode. If you reimplement this class a make your own event filter, make sure to call this function from your filter.

Parameters:

o | Object that has received an event.
e | The event.

bool showPage ( QWidget *w ) | ### showPage

[protected]

void addPageWidget ( QFrame *page, const QStringList &items, const QString &header, const QPixmap &pixmap ) | ### addPageWidget

[protected]

void InsertTreeListItem (const QStringList &items, const QPixmap &pixmap, QFrame *page) | ### InsertTreeListItem

[protected]

QWidget * FindParent () | ### FindParent

[protected]

void virtual_hook ( int id, void* data ) | ### virtual_hook

[protected virtual]

- Author: Espen Sand (espen@kde.org)
- Generated: root on macppc.ports.openbsd.org on Sat Sep 6 10:36:37 2003, using kdoc 2.0a54.